import es, gamethread, random, popuplib, playerlib, cfglib
# Thanks SuperDave and jeff91 for dict help and DanielB

# Public #
info = es.AddonInfo()
info.name     = "Deathmatch"
info.version  = "1.4"
info.url      = "None"
info.basename = "sic_deathmatch"
info.author   = "sicman_adrian"
es.ServerVar('sic_dm', info.version, 'Red Vs Blue Deathmatch').makepublic()
#Public#

#
config = cfglib.AddonCFG(es.getAddonPath("deathmatch") + "/deathmatch.cfg")
config.text("*******************")
config.text("Deathmatch Settings")
config.text("*******************")
primaryweapons = config.cvar("primary_names",     "M4A1 AK47 AWP Scout SG552 Galil Famas SG550 AUG m249 G3SG1 UMP45 MP5NAVY M3 xm1014 TMP Mac10 P90", "Priamry menu list")
secondary = config.cvar("pistol_names",   "Usp Glock Deagle P228 Elite FiveSeven", "Pistol menu list")
deathtype = config.cvar("deathtype",      1, "Death Type: 1 = no dissovle, 2 =  Energy Effect ,3 = Heavy Electrical Effect, 4 = Light Electrical  Effect,5 = Core Effect,6 = Random")
config.text("*************************")
config.text("Spawn Protection Settings")
config.text("*************************")
spawn_protection   = config.cvar("spawn_protection",   1, "Enable or Disable Spawn Protection")
protection_time   = config.cvar("protection_time",   5, "Time Protected")
protection_health   = config.cvar("protection_health",   1124, " Protection Health ,Recommend 1124")
protection_alpha   = config.cvar("protection_alpha",   100, " Alpha When spawned ,100 half invisible, Default 255")
config.text("*************************")
config.text("       GamesModes        ")
config.text("*************************")
gamemodes_enable = config.cvar("gamemodes_enable",   1, "Enable/Disable gamemodes")
gamemodes_redvsblue = config.cvar("gamemodes_redvsblue",   1, "Red Vs Blue Gamemode,So far Red vs blue Is just Blue and Red Master Chief skins for both teams")
gamemodes_headshotonly = config.cvar("gamemodes_headshotonly",   0, "Head Shot Only Gamemode")
config.text("*************************")
config.text("         Extras          ")
config.text("*************************")
noblock   = config.cvar("noblock",   1, "Enable and Disables noblock Allowing people to walk throught other players")

config.write()
#

# Do not Touch
weapon_dict = {}
protection_dict = {}
weapon_ammo_dict = {'weapon_m4a1':90,'weapon_ak47':90,'weapon_awp':30,'weapon_Scout':90,'weapon_sg552':90, 'weapon_galil':90,'weapon_famas':90,'weapon_sg550':90,'weapon_aug':90,'weapon_m249':200,'weapon_g3sg1':90, 'weapon_ump45':100,'weapon_mp5navy':120,'weapon_m3':32,'weapon_xm1014':32,'weapon_tmp':120,'weapon_mac10':120, 'weapon_p90':100,'weapon_usp':100,'weapon_glock':100,'weapon_deagle':35,'weapon_p228':52,'weapon_elite':120,
'weapon_fiveseven':100}

def msg(text):
    es.msg('#multi', '#green[Deathmatch]#lightgreen ' + text)

def tell(userid, text):
    es.tell(userid, '#multi', '#green[Deathmatch]#lightgreen ' + text)

def spawnmsg(text):
    es.msg('#multi', '#green[Deathmatch Spawn Protection]#lightgreen ' + text)

def spawntell(userid, text):
    es.tell(userid, '#multi', '#green[Deathmatch Spawn Protection]#lightgreen ' + text)

def load():
    global mainmenu, primarymenu, pistolmenu
    config.execute()
    msg('Loaded')
    es.set('eventscripts_noisy', 1)
    mainmenu = popuplib.create('mainmenu')
    mainmenu.addline('Deathmatch')
    mainmenu.addline('----------------------')
    mainmenu.addline('->1. New weapons')
    mainmenu.addline('->2. Same weapons')
    mainmenu.addline('->3. Same weapons every time')
    mainmenu.addline('->4. Random weapons')
    mainmenu.addline('->5. Random weapons every time')
    mainmenu.addline('----------------------')
    mainmenu.menuselect = mainmenu_menuselect
    primarymenu = popuplib.easymenu('primarymenu', '_popup_choice', primarymenu_menuselect)
    primarymenu.settitle('Primary weapons')
    for c in str(primaryweapons).split(): primarymenu.addoption(c, c)
    pistolmenu = popuplib.easymenu('pistolmenu', '_popup_choice', pistolmenu_menuselect)
    pistolmenu.settitle('Pistols')
    for c in str(secondary).split(): pistolmenu.addoption(c, c)
    es.addons.registerClientCommandFilter(superdaves_client_filter)
    if spawn_protection == 1:
        spawnmsg('Loaded')
    if gamemodes_enable == 1:
        gamemodes()

def unload():
    popuplib.delete('mainmenu')
    popuplib.delete('pistolmenu')
    popuplib.delete('primarymenu')
    msg('And Gamemodes Unloaded')
    es.unload('deathmatch/gamemodes/rvb')
    es.unload('deathmatch/gamemodes/headshotonly')
    es.addons.unregisterClientCommandFilter(superdaves_client_filter)

def gamemodes():
    if gamemodes_redvsblue == 1:
        es.load('deathmatch/gamemodes/rvb')
        msg('Red vs Blue Gamemode Enable')
    if gamemodes_headshotonly == 1:
        es.load('deathmatch/gamemodes/headshotonly')
        msg('Head Shot Only Gamemode Enable')

def mainmenu_menuselect (userid, choice, popupid):
    if choice == 1:
        weapon_dict[userid]['menu'] = 0
        popuplib.send('pistolmenu', userid)
    elif choice == 2:
        stripplayer(userid)
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, weapon_dict[userid]['primary']))
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, weapon_dict[userid]['pistol']))
    elif choice == 3:
        weapon_dict[userid]['menu'] = 1
        stripplayer(userid)
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, weapon_dict[userid]['primary']))
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, weapon_dict[userid]['pistol']))
    elif choice == 4:
        stripplayer(userid)
        random_primary = random.choice(str(primaryweapons).split())
        random_pistol = random.choice(str(secondary).split())
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_primary))
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_pistol))
    elif choice == 5:
        weapon_dict[userid]['menu'] = 2
        stripplayer(userid)
        random_primary = random.choice(str(primaryweapons).split())
        random_pistol = random.choice(str(secondary).split())
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_primary))
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_pistol))

def primarymenu_menuselect (userid, choice, popupid):
    weapon_dict[userid]['primary'] = choice
    gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, choice))

def pistolmenu_menuselect (userid, choice, popupid):
    weapon_dict[userid]['pistol'] = choice
    stripplayer(userid)
    gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, choice))
    popuplib.send('primarymenu', userid)

def player_spawn(event_var):
    global weapon_dict, protection_dict
    userid = int(event_var['userid'])
    myPlayer = playerlib.getPlayer(userid)
    alive = myPlayer.attributes['isdead']
    bot = myPlayer.attributes['isbot']
    if userid not in weapon_dict:
        weapon_dict[userid] = {'primary':None,'Secondary':None,'menu':0}
    if userid not in protection_dict:
        protection_dict[userid] = {'invincible':0}
    if weapon_dict[userid]['menu'] == 0:
        if alive == 0:
            popuplib.send('mainmenu', userid)
    elif weapon_dict[userid]['menu'] == 1:
          if alive == 0:
              stripplayer(userid)
              gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, weapon_dict[userid]['primary']))
              gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, weapon_dict[userid]['pistol']))
    elif weapon_dict[userid]['menu'] == 2:
          if alive == 0:
              stripplayer(userid)
              random_primary = random.choice(str(primaryweapons).split())
              random_pistol = random.choice(str(secondary).split())
              gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_primary))
              gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_pistol))
    if bot:
        stripplayer(userid)
        random_primary = random.choice(str(primaryweapons).split())
        random_pistol = random.choice(str(secondary).split())
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_primary))
        gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_%s' % (userid, random_pistol))
    if spawn_protection == 1:
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', protection_health)
        myPlayer.set("color", (255, 255, 255, protection_alpha))
        protection_dict[userid]['invincible'] = 1
        gamethread.delayed(protection_time, removeprotection, (userid))
    if noblock == 1:
        es.setplayerprop(userid, 'CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup', 2)

def player_activate(event_var):
    global protection_dict
    userid = event_var["userid"]
    if userid not in protection_dict:
        protection_dict[userid] = {'invincible':None}

def player_hurt(event_var):
    userid = int(event_var['userid'])
    if protection_dict[userid]['invincible'] == 1:
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', protection_health)

def player_death(event_var):
    userid = event_var["userid"]
    if deathtype == 6:
        mode = random.randint(1,5)
    else:
        mode = deathtype

    if mode == 1:
          es.server.queuecmd("es_fire %s cs_ragdoll kill" % userid)
          es.server.queuecmd('est_spawn %s 1'%userid)
          est("removeidle weapon")
    else:
          es.server.queuecmd('es_give %s env_entity_dissolver' % userid)
          es.server.queuecmd('es_fire %s env_entity_dissolver AddOutput "target cs_ragdoll"' % userid)
          es.server.queuecmd('es_fire %s env_entity_dissolver AddOutput "magnitude 1"' % userid)
          es.server.queuecmd('es_fire %s env_entity_dissolver AddOutput "dissolvetype %s"' % (userid,mode-2))
          es.server.queuecmd('es_fire %s env_entity_dissolver Dissolve' % userid)
          es.delayed(0.3, 'est_spawn %s 1'%userid)
          est("removeidle weapon")

def player_team(event_var):
    userid = int(event_var['userid'])
    myPlayer = playerlib.getPlayer(event_var['userid'])
    dead = myPlayer.attributes['isdead']
    if event_var['es_userteam'] >= 2:
        if dead == 1:
            es.server.queuecmd('est_spawn %s 1'%userid)

def weapon_reload(event_var):
   weapon = event_var['weapon']
   if weapon in weapon_ammo_dict:
       playerlib.getPlayer(event_var['userid']).set('ammo', weapon, weapon_ammo_dict[weapon])

def kill():
    est("remove func_hostage_rescue")
    est("remove hostage_entity")
    est("remove func_bomb_target")
    est("remove weapon_c4")
    est("remove func_buyzone")

def round_start(event_var):
    msg('Type guns to pull up guns menu')
    msg('Type !spec to move to spec')
    kill()

def est(arg):
    es.server.queuecmd('est_' + arg)

def stripplayer(userid):
    es.server.queuecmd('es_xfire %s player_weaponstrip kill' % userid)
    es.server.queuecmd('es_xgive %s player_weaponstrip' % userid)
    es.server.queuecmd('es_xfire %s player_weaponstrip strip' % userid)
    gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_knife' % userid)

def es_player_chat(event_var):
    userid = event_var["userid"]
    text = event_var['text']
    myPlayer = playerlib.getPlayer(userid)
    alive = myPlayer.attributes['isdead']
    team = myPlayer.attributes['teamid']
    if text == 'guns':
        if alive == 0:
            if team >= 1:
                popuplib.send('mainmenu', userid)
    if text == '!spec':
        es.changeteam(userid,  '1')

def superdaves_client_filter(userid, args):
   if args[0].lower() == 'drop':
      est("removeidle weapon")
   return True 

def removeprotection(userid):
    myPlayer = playerlib.getPlayer(userid)
    myPlayer.set("color", (255, 255, 255, 255))
    es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 100)
    protection_dict[userid]['invincible'] = 0

def player_disconnect(event_var):
    userid = int(event_var['userid'])
    try:
        del weapon_dict[userid]
        del protection_dict[userid]
    except:
        es.msg('Error in script - Reccommend Reload')